#include<iostream>
#include<string>
using namespace std;

bool full(int m, char x[]){
	for(int i=0;i<m;i++){
		if(x[i]=='.'){
			return false;
		}
	}
	return true;
}

main(){
	
	
	int n,m;
	cin>>n>>m;
	char x[m];
	for(int i=0;i<m;i++){
		cin>>x[i];
	}
	
	int minX=6969,maxX=-6969,minS=6969,maxS=-6969;
	
	for(int i=0;i<m;i++){
		if(x[i]=='X'){
			if(minX>i){
				minX=i;
			}
			if(maxX<i){
				maxX=i;
			}
		}
		else if(x[i]=='S'){
			if(minS>i){
				minS=i;
			}
			if(maxS<i){
				maxS=i;
			}
		}
	}
	
	while(!full(m,x)){
		if(minX!=maxX && x[minX+1]=='.'  ){
			x[minX+1]='X';
		}
		if(minX>0 && x[minX-1]=='.'){
			x[minX-1]='X';
			minX--;
		}
		if(minX!=maxX && x[maxX-1]=='.'){
			x[maxX-1]='X';
		}
		if(maxX<m-1 && x[maxX+1]=='.'){
			x[maxX+1]='X';
			maxX++;
		}		
		
		if(maxS<m-1 && x[maxS+1]=='.'){
			x[maxS+1]='S';
			maxS++;
		}
		if(minS>0 && x[minS-1]=='.'){
			x[minS-1]='S';
			minS--;
		}
	}
	int count=0;
	for(int i=0;i<m;i++){
		if(x[i]=='S'){
			count++;
		}
	}
	cout<<count;
	
	return 0;
}